package dsnserver;
import java.sql.ResultSet;
import java.sql.SQLException;

/**********************************************
 * This class is used to request the logs from 
 * the BTnode.
 * It looks which nodes are here by looking
 * to the dsninfo table and sends after some 
 * seconds a new log request to the next DSNnode
 * in the table.  
 * 
 * @author  kaltt
 **********************************************/
public class ThreadLogging_old extends Thread{

	private Communication myComm;
	
	public ThreadLogging_old(Communication myComm) {
		this.myComm = myComm;
	}
	
	
	public void run(){
		
		String DSNIDnext,MsgID;

		int olderTime_int =  Integer.parseInt(GetProperty.get("getDSN_Ping"));			
		String olderTime;
		
		//From milliseconds into HH:mm:ss  
		double hour_d = (Math.floor(olderTime_int/3600000));
		String hour = Double.toString(hour_d);
		hour = hour.substring(0,hour.length()-2);
		if (hour.length()<2){hour = "0" + hour;}
		double min_d = Math.floor((olderTime_int-3600000*hour_d)/60000);
		String min = Double.toString(min_d);
		min = min.substring(0,min.length()-2);
		if (min.length()<2){min = "0" + min;}
		double sec_d = Math.floor((olderTime_int-3600000*hour_d-60000*min_d)/1000);
		String sec = Double.toString(sec_d);
		sec = sec.substring(0,sec.length()-2);
		if (sec.length()<2){sec = "0" + sec;}
		olderTime = hour+min+sec;
		
		ResultSet result = null;
		ResultSet result2 = null;

		while(true){
			SQLDBcommunication.lock();
			result = SQLDBcommunication.getResultsFromDB("" +
					"SELECT `DSNID` FROM `dsninfo` " +
					"WHERE (`DSNlastSeen` > now() - " + olderTime + ")");

//System.out.println(	"SELECT `DSNID` FROM `dsninfo` " +
//					"WHERE (`DSNlastSeen` > now() - " + olderTime + ")");			
			try {
				int i = 0;
				//DSNID = null;
				String DSNID = "";
				while (result.next()){
					DSNID = DSNID + result.getString("DSNID") + " ";
					i++;
				}
				SQLDBcommunication.unlock();
				String[] DSNIDn = DSNID.split(" ");
				for (int j=0;j<i;j++)
				{
					DSNIDnext = DSNIDn[j].trim();
					//String DSNID = result.getString("DSNID");
					SQLDBcommunication.lock();
					result2 = SQLDBcommunication.getResultsFromDB("" +
							"SELECT `MsgID` FROM `dsnlog` " +
							"WHERE `DSNID` = '" + DSNIDnext + "' " +
							"ORDER BY (`ID`) DESC LIMIT 1");

					if (result2.next()){
					
						MsgID = result2.getString("MsgID");
//System.err.println(MsgID);	
						myComm.lock();
						myComm.writeLine("rpcs " + DSNIDnext + " slog get " + CmdParserGetAddr.DSNnodeAddr + " " + MsgID);
						myComm.unlock();
					}
					else{
//System.out.println("First log request of node " + DSNID);
						myComm.lock();
						myComm.writeLine("rpcs " + DSNIDnext + " slog get " + CmdParserGetAddr.DSNnodeAddr);
						myComm.unlock();
					}
					SQLDBcommunication.unlock();
					try {
						sleep(Integer.parseInt(GetProperty.get("logging")));
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			try {
				sleep(Integer.parseInt(GetProperty.get("logging")));
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}									
		}
	}
}
