package dsnserver;

import java.text.SimpleDateFormat;
import java.util.Date;

/**********************************************
 * A function wich is used as a XmlRpc function.
 * It gives back the server time. 
 *
 * @author kaltt
 *
 **********************************************/
public class XmlRpcGetServerTime {

	public XmlRpcGetServerTime() {
		super();
	}

	/**********************************************
	 * A function wich is used as a XmlRpc function.
	 * It gives back the server time.
	 *
	 * @return String time (yyyy-MM-dd HH:mm:ss)
	 * 
	 **********************************************/
	public String getServerTime() {		
		Date now = new Date();
		SimpleDateFormat df = new SimpleDateFormat( "yyyy-MM-dd HH:mm:ss" );
		
		String time = df.format(now);
		
		return time;
	}
}
