package dsnserver;
import java.io.*;
import java.util.Properties;


/**********************************************
 * A Class with a function to read out values 
 * out of the Server.properties file.
 * 
 * @author kaltt
 *
 **********************************************/
 public class GetProperty{
	 
	 
	 /**********************************************
	 * A functin to read out values out of the 
	 * Server.properties file.
	 **********************************************/
	 public static String get(String key){
	 
	   Properties props=new Properties();
	 
	   try{
	     props.load( new FileInputStream(new File("Server.properties")));
	   }catch(IOException ie){
	     System.out.println("Error reading file");
	   }
	   
	   String value = props.getProperty(key);
		if(value.indexOf("#") != -1){
			value = value.substring(0, value.indexOf("#"));
		}
	   //System.out.println("value: " + value + "ende");
	   return value;
	 }
	 
	 
	 public static String get(String key, String def){
		 
		   Properties props=new Properties();
		 
		   try{
		     props.load( new FileInputStream(new File("Server.properties")));
		   }catch(IOException ie){
		     System.out.println("Error reading file");
		   }
		   
		   String value = props.getProperty(key, def);
			if(value.indexOf("#") != -1){
				value = value.substring(0, value.indexOf("#"));
			}
		   //System.out.println("value: " + value + "ende");
		   return value;
		 }
 } 